; Patch by Conn
; apply on Street Fighter 2 Turbo (USA) with header

header
hirom



org $C00AB7    ; native hook to induce track change
JSL msuRoutine ; there is no free space in rom, these are ascii credits overwritten which are not used
NOP

org $C00B13    ; mute spc in case new track s introduced
JSL pause



org $e70300
msuRoutine:
STA $1CB7
LDY #$Fa
PHA
LDA $2002      ;check if msu found
CMP #$53               
BEQ msufound
PLA   
RTL            ; spc is played
msufound:
STZ $2006      ; mute old track
LDA $1CB7
STA $2004   ; save track
STZ $2005
msuready:
Bit $2000
bvs msuready ; check if msu is ready
PHX
LDA $1CB7
TAX
LDA $e70600,x ;load loop value
sta $2007  
PLX
lda #$FF   ; volume
sta $2006
lda $2000
AND #$08
BNE playspc ; error bit set? 
PLA
LDY #$F9 ;mute SPC
RTL
playspc:
PLA
RTL



pause:
INY
STY $1CAD
PHA
LDA $2002      ;check if msu found
CMP #$53   
BEQ continue   
PLA
RTL            ; spc is played
continue:  ; mute track when in PAUSE modus
PLA
CMP #$FB   ; prevent double spc play in menu/options
bne $06
stz $2007
stz $1CB7
CMP #$F0   ; mute start
bne $06
stz $2007
stz $1CB7
CMP #$F3   ; pause start
bne $03
stz $2007
CMP #$F6    ; end of battle 
bne $06
stz $2007
stz $1CB7
CMP #$F7    ; begin of battle
bne check
PHA
PHX
LDA $1CB7
TAX
LDA $e70600,x ;load loop value
STA $2007  ; also wenn ein theme endlos looped dann mach hier eine 03 auf 2007
PLX
PLA
check:
CMP #$F4   ; end pause
bne end
PHA
PHX
LDA $1CB7
TAX
LDA $e70600,x ;load loop value
STA $2007  ; also wenn ein theme endlos looped dann mach hier eine 03 auf 2007
PLX
PLA
end:
RTL



ORG $e70600 ; loop table 03:loop, 01 non-loop
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f (not used)
db $01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03 ; themes 10-1f
db $03,$03,$01,$03,$03,$03,$03,$01,$03,$01,$01,$01,$03,$03,$01,$01 ; themes 20-2f
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 30-3f (tracks end with 31)
